/**
 * The class name contract for the action trigger component
 */
export interface ActionTriggerClassNameContract {
    /**
     * The root of the action trigger component
     */
    actionTrigger?: string;
    /**
     * The action trigger glyph
     */
    actionTrigger_glyph?: string;

    /**
     * The justified appearance modifier
     */
    actionTrigger__justified?: string;

    /**
     * The lightweight appearance modifier
     */
    actionTrigger__lightweight?: string;

    /**
     * The outline appearance modifier
     */
    actionTrigger__outline?: string;

    /**
     * The primary appearance modifier
     */
    actionTrigger__primary?: string;

    /**
     * The stealth appearance modifier
     */
    actionTrigger__stealth?: string;

    /**
     * The disabled modifier
     */
    actionTrigger__disabled?: string;

    /**
     * Action trigger class name used when checking glyph and content
     */
    actionTrigger__hasGlyphAndContent?: string;
}
