## Best practices
Use the *divider* to show a change in the content between two blocks of information. The content surrounding the *divider* determine the spacing above and below it. For example, headings of differing importance require different spacing above them, but it is possible to apply spacing preselects for space above and/or below the *divider*.

### Usage guidance
Use *divider* to separate sections that may not otherwise have a clear beginning or end, and to separate information blocks where the context or continuity changes between the blocks.

## Accessibility
The *divider* is intrinsically set as `role="separator"`, so it's not necessary to include when the *divider* separates and distinguishes sections of content.  However, when changing the look, functional, interactive, or structural relevance implied by the `hr` element a `role="presentation"` may be applied.